#include "FiveWin.ch"

CLASS RRW

	DATA cRi_Library
	DATA cRi_Report, cnRi_Report
	DATA cRi_OutFile
	DATA cRi_Printer
	DATA cRi_WPTR
	DATA nRi_Copies
	DATA cRi_Filter
	DATA cRi_Query
	DATA lRi_DispErr
	DATA lRi_Status
	DATA lActive
	DATA cDataDirectory
	DATA cLibDirectory

	DATA cDataPath
	DATA cControlFile
	DATA cAlias
	
	METHOD New( cControlFile, cReport , lQuery, lPreview, nBegPage ;
		, nEndPage, cDataDirectory, cLibDirectory ) CONSTRUCTOR
		
	METHOD End()
	METHOD Print()
	METHOD Activate() INLINE ::print()
	METHOD SetFilter( cVar )
	METHOD OpenControlFile()
	METHOD CloseControlFile()
	METHOD SetPrinter( cVar )
	METHOD Results()
ENDCLASS

METHOD New( cControlFile, cReport, lQuery, lPreview, nBegPage, nEndPage ;
		, cDataDirectory, cLibDirectory ) CLASS RRW

	DEFAULT cControlFile := "RREPORTS.DBF" ;
		,	lQuery := .F.	;
		,	lPreview := .F. ;
		,	nBegPage := 1	;
		,	nEndPage := 99999 ;
		,   cDataDirectory := "\"+curDir() ;
		,	cLibDirectory := "\"+curDir()
		
	::cAlias = alias()
	::lActive = .T.
	::cControlFile = cControlFile
	::cRi_Report = upper(alltrim(cReport))
	::cDataDirectory := cDataDirectory
	::cLibDirectory := cLibDirectory
	
	dbUseArea( .T., nil, ::cControlFile, "RRW", .T. )
	locate for upper(alltrim(RRW->RI_REPORT)) == ::cRi_Report
	if !found()
		msginfo("Requested Report:"+CRLF+::cRi_Report+CRLF+"was not found","REPORT")
		::end()
		return nil
	endif
	::cnRi_Report := ltrim(str(recno()))
	if rLock()
		RRW->RI_QUERY := iif(lQuery,"?","S")
		RRW->RI_PRINTER := iif(lPreview,"D","P")
		RRW->RI_BEGPAGE := nBegPage
		RRW->RI_ENDPAGE := nEndPage
		dbunlock()
		dbCommit()
		dbCloseArea()
	endif	
	if !empty(::cAlias) .and. select(::cAlias) > 0
		dbSelectArea( ::cAlias )
	endif	
return nil



METHOD End() CLASS RRW
	::lActive := .F.
	::CloseControlFile()
return nil	
		
	
METHOD Print() CLASS RRW
	if ::lActive
		WaitRun("RRWRUN "+::cControlFile+" "+::cnRi_Report ;
			+" /R"+::cLibDirectory +" /D"+::cDataDirectory )
	endif
return nil	

METHOD SetPrinter( cVar ) CLASS RRW
	IF ::lActive
		::OpenControlFile()
		IF rLock()
			RRW->RI_WPTR := cVar
			dbUnLock()
		ENDif
		::CloseControlFile()
	ENDif
return nil	

METHOD SetFilter( cVar ) CLASS RRW
	IF ::lActive
		::OpenControlFile()
		IF rLock()
			RRW->RI_FILTER := cVar
			RRW->RI_QUERY := "O"
			dbUnLock()
		ENDif
		::CloseControlFile()
	ENDif
Return nil	

METHOD OpenControlFile() CLASS RRW
	if select("RRW") = 0
		dbUseArea( .T., nil, ::cControlFile, "RRW", .T. ) 
	endif
	dbGoto( val(::cnRi_Report) ) 
return nil

METHOD CloseControlFile() CLASS RRW
	if select("RRW") > 0
		dbselectarea("RRW")
		dbCloseArea()
	endif
	if !empty( ::cAlias ) .and. select( ::cAlias ) > 0
		dbselectarea( ::cAlias )
	endif
return nil

METHOD Results() CLASS RRW
	local cAlias := alias()
	local aResult[5]
	local cOut := cFilePath( ::cControlFile )+"\RRUNOUT.dbf"
	IF ::lActive
		if file( cOut )
			dbUseArea( .T., nil, cOut, "RRWOUT", .T. )
			IF select("RRWOUT") != 0
				aResult[1] := RRWOUT->RO_ECODE		// Error code 	 C,1
				aResult[2] := RRWOUT->RO_EMSG		// Message		 C,80
				aResult[3] := RRWOUT->RO_REPORTS	// Reports Done	 N,2
				aResult[4] := RRWOUT->RO_PAGES		// Pages		 N,9
				aResult[5] := RRWOUT->RO_RIRECNO	// Last Rep Done N,5
				dbCloseArea()
			ENDif	
			if !empty(cAlias) .and. select(cAlias)>0
				dbselectArea(cAlias)
			endif	
		endif
	ENDif
return( aResult )	


	
